diff a/test/micro/org/openjdk/bench/valhalla/field/set/Inline32int.java b/test/micro/org/openjdk/bench/valhalla/field/set/Inline32int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/set/Inline32int.java
@@ -0,0 +1,114 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.set;
+
+import org.openjdk.bench.valhalla.field.util.StatesQ32int;
+import org.openjdk.bench.valhalla.types.Q32int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline32int extends StatesQ32int {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q32int getRef(int i) {
+        return new Q32int(i);
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q32int getVal(int i) {
+        return new Q32int(i);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q32int(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getVal(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Def_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q32int()  ;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q32int(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getVal(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Def_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q32int()  ;
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/set/Inline64byte.java b/test/micro/org/openjdk/bench/valhalla/field/set/Inline64byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/set/Inline64byte.java
@@ -0,0 +1,114 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.set;
+
+import org.openjdk.bench.valhalla.field.util.StatesQ64byte;
+import org.openjdk.bench.valhalla.types.Q64byte;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64byte extends StatesQ64byte {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q64byte getRef(int i) {
+        return new Q64byte(i);
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q64byte getVal(int i) {
+        return new Q64byte(i);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q64byte(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getVal(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Def_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q64byte()  ;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q64byte(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getVal(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Def_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q64byte()  ;
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/set/Inline64int.java b/test/micro/org/openjdk/bench/valhalla/field/set/Inline64int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/set/Inline64int.java
@@ -0,0 +1,114 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.set;
+
+import org.openjdk.bench.valhalla.field.util.StatesQ64int;
+import org.openjdk.bench.valhalla.types.Q64int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64int extends StatesQ64int {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q64int getRef(int i) {
+        return new Q64int(i);
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q64int getVal(int i) {
+        return new Q64int(i);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q64int(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getVal(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Def_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q64int()  ;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q64int(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getVal(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Def_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q64int()  ;
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/set/Inline64long.java b/test/micro/org/openjdk/bench/valhalla/field/set/Inline64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/set/Inline64long.java
@@ -0,0 +1,162 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.set;
+
+import org.openjdk.bench.valhalla.field.util.StatesQ64long;
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64long;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64long extends StatesQ64long {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Object getObj(int i) {
+        return new Q64long(i);
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Int64 getInt(int i) {
+        return new Q64long(i);
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q64long getRef(int i) {
+        return new Q64long(i);
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q64long getVal(int i) {
+        return new Q64long(i);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q64long(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Obj_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = (Q64long) getObj(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Int_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = (Q64long) getInt(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getVal(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Def_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q64long()  ;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q64long(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Obj_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = (Q64long) getObj(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Int_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = (Q64long) getInt(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getVal(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Def_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q64long()  ;
+        }
+    }
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/util/PrimitiveStates.java b/test/micro/org/openjdk/bench/valhalla/field/util/PrimitiveStates.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/util/PrimitiveStates.java
@@ -0,0 +1,170 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.util;
+
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.jmh.annotations.Setup;
+
+public class PrimitiveStates extends SizeBase {
+
+    public static class P64byte {
+
+        public byte f0;
+        public byte f1;
+        public byte f2;
+        public byte f3;
+        public byte f4;
+        public byte f5;
+        public byte f6;
+        public byte f7;
+
+        public P64byte(long v) {
+            this((byte) (v >>> 56), (byte) (v >>> 48), (byte) (v >>> 40), (byte) (v >>> 32), (byte) (v >>> 24), (byte) (v >>> 16), (byte) (v >>> 8), (byte) (v));
+        }
+
+        public P64byte(byte v0, byte v1, byte v2, byte v3, byte v4, byte v5, byte v6, byte v7) {
+            this.f0 = v0;
+            this.f1 = v1;
+            this.f2 = v2;
+            this.f3 = v3;
+            this.f4 = v4;
+            this.f5 = v5;
+            this.f6 = v6;
+            this.f7 = v7;
+        }
+
+    }
+
+    public static class Primitive64byte extends SizeState {
+        public P64byte[] arr;
+        @Setup
+        public void setup() {
+            arr = new P64byte[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new P64byte(i);
+            }
+        }
+    }
+
+
+    public static class P64int {
+
+        public int f0;
+        public int f1;
+
+        public P64int(long v) {
+            this((int) (v >>> 32), (int) v);
+        }
+
+        public P64int(int hi, int lo) {
+            this.f0 = hi;
+            this.f1 = lo;
+        }
+
+    }
+
+    public static class Primitive64int extends SizeState {
+        public P64int[] arr;
+        @Setup
+        public void setup() {
+            arr = new P64int[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new P64int(i);
+            }
+        }
+    }
+
+    public static class P64long {
+
+        public long f0;
+
+        public P64long(long v0) {
+            this.f0 = v0;
+        }
+
+    }
+
+    public static class Primitive64long extends SizeState {
+        public P64long[] arr;
+        @Setup
+        public void setup() {
+            arr = new P64long[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new P64long(i);
+            }
+        }
+    }
+
+
+    public static class P32int {
+
+        public int f0;
+
+        public P32int(int val) {
+            this.f0 = val;
+        }
+    }
+
+    public static class Primitive32int extends SizeState {
+        public P32int[] arr;
+        @Setup
+        public void setup() {
+            arr = new P32int[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new P32int(i);
+            }
+        }
+    }
+
+    public static class P128int {
+
+        public int f0;
+        public int f1;
+        public int f2;
+        public int f3;
+
+        public P128int(long v) {
+            this(0, 0, (int) (v >>> 32), (int) v);
+        }
+
+        public P128int(int v0, int v1, int v2, int v3) {
+            this.f0 = v0;
+            this.f1 = v1;
+            this.f2 = v2;
+            this.f3 = v3;
+        }
+    }
+
+    public static class Primitive128int extends SizeState {
+        public P128int[] arr;
+        @Setup
+        public void setup() {
+            arr = new P128int[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new P128int(i);
+            }
+        }
+    }
+
+}
+
diff a/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ128int.java b/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ128int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ128int.java
@@ -0,0 +1,111 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.util;
+
+import org.openjdk.bench.valhalla.types.Int128;
+import org.openjdk.bench.valhalla.types.Q128int;
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.jmh.annotations.Setup;
+
+public class StatesQ128int extends SizeBase {
+
+    public static class ObjWrapper {
+        public Object f;
+
+        public ObjWrapper(Object f) {
+            this.f = f;
+        }
+    }
+
+    public static class ObjState extends SizeState {
+        public ObjWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new ObjWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new ObjWrapper(new Q128int(i));
+            }
+        }
+    }
+
+    public static class IntWrapper {
+        public Int128 f;
+
+        public IntWrapper(Int128 f) {
+            this.f = f;
+        }
+    }
+
+    public static class IntState extends SizeState {
+        public IntWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new IntWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new IntWrapper(new Q128int(i));
+            }
+        }
+    }
+
+
+    public static class RefWrapper {
+        public Q128int f;
+
+        public RefWrapper(Q128int f) {
+            this.f = f;
+        }
+    }
+
+    public static class RefState extends SizeState {
+        public RefWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new RefWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new RefWrapper(new Q128int(i));
+            }
+        }
+    }
+
+
+    public static class ValWrapper {
+        public Q128int f;
+
+        public ValWrapper(Q128int f) {
+            this.f = f;
+        }
+    }
+
+    public static class ValState extends SizeState {
+        public ValWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new ValWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new ValWrapper(new Q128int(i));
+            }
+        }
+    }
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ32int.java b/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ32int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/util/StatesQ32int.java
@@ -0,0 +1,111 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.util;
+
+import org.openjdk.bench.valhalla.types.Int32;
+import org.openjdk.bench.valhalla.types.Q32int;
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.jmh.annotations.Setup;
+
+public class StatesQ32int extends SizeBase {
+
+    public static class ObjWrapper {
+        public Object f;
+
+        public ObjWrapper(Object f) {
+            this.f = f;
+        }
+    }
+
+    public static class ObjState extends SizeState {
+        public ObjWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new ObjWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new ObjWrapper(new Q32int(i));
+            }
+        }
+    }
+
+    public static class IntWrapper {
+        public Int32 f;
+
+        public IntWrapper(Int32 f) {
+            this.f = f;
+        }
+    }
+
+    public static class IntState extends SizeState {
+        public IntWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new IntWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new IntWrapper(new Q32int(i));
+            }
+        }
+    }
+
+
+    public static class RefWrapper {
+        public Q32int f;
+
+        public RefWrapper(Q32int f) {
+            this.f = f;
+        }
+    }
+
+    public static class RefState extends SizeState {
+        public RefWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new RefWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new RefWrapper(new Q32int(i));
+            }
+        }
+    }
+
+
+    public static class ValWrapper {
+        public Q32int f;
+
+        public ValWrapper(Q32int f) {
+            this.f = f;
+        }
+    }
+
+    public static class ValState extends SizeState {
+        public ValWrapper[] arr;
+        @Setup
+        public void setup() {
+            arr = new ValWrapper[size];
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new ValWrapper(new Q32int(i));
+            }
+        }
+    }
+
+
+}
